import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress myRemoteLocation;

import lusidOSC.*;
LusidClient lusidClient;

float mx;
float my;
int bs = 20;
int m;
boolean bover = true;
boolean locked = false;
float bdifx = 0.0; 
float bdify = 0.0;
int numBalls = 2;
float spring = 0.05;
float friction = -0.4;
Ball[] balls = new Ball[numBalls];
PFont font;

void setup() {

  size(300,300,JAVA2D);
  frameRate(30);
  rectMode(CENTER);
  
  oscP5 = new OscP5(this,5001);
  
  myRemoteLocation = new NetAddress("127.0.0.1",5001);
  
  lusidClient = new LusidClient(this);
  mx = height/2;
  my = width/2;
  stroke(0);
  background(120);
  noStroke();
  smooth();
  
  balls[0] = new Ball(300, 205, height/8, 0, balls);
 balls[1] = new Ball(mx, my, height/7, 1, balls);
   fill(0);
 
}

void draw()
{
  background(120);
  LusidObject[] lusidObjectList = lusidClient.getLusidObjects();
  for (int l = 0; l < numBalls; l++) {
    balls[l].collide();
    balls[l].move();
    balls[l].display();
}

if(lusidObjectList.length > 0){
balls[0].x = width/2 + lusidObjectList[0].getX();
balls[0].y = height/2 - lusidObjectList[0].getY();
}
/*
  if (mouseX > mx-bs && mouseX < mx+bs && 
    mouseY > my-bs && mouseY < my+bs) {
      
    bover = true;  
    if(!locked) { 

    } 
  } 
  else {
    stroke(100);
    bover = false;
  }
*/
}

class Ball {
  float x, y;
  float diameter;
  float vx = 0;
  float vy = 0;
  int id;
  float mass; 
  float spring = 0.2;
  float rest_posx;  
  float rest_posy;
  Ball[] others;

  Ball(float xin, float yin, float din, int idin, Ball[] oin) {
    x = xin;
    y = yin;
    diameter = din;
    id = idin;
    others = oin;
  }


void collide() {
  for (int i = id + 1; i < numBalls; i++) {
    float dx = others[i].x - x;
    float dy = others[i].y - y;
    float distance = sqrt(dx*dx + dy*dy);
    float minDist = others[i].diameter/2 + diameter/2;
    if (distance < minDist) { 
      float angle = atan2(dy, dx);
      float targetX = x + cos(angle) * minDist;
      float targetY = y + sin(angle) * minDist;
      float ax = (targetX - others[i].x) * spring;
      float ay = (targetY - others[i].y) * spring;
      vx -= ax;
      vy -= ay;
      others[i].vx += ax;
      others[i].vy += ay;
    }
  }   
}


void move() {

  OscMessage myMessage = new OscMessage("/test");
  
  myMessage.add(123);
  myMessage.add(12.34);
  myMessage.add("some text!");
  
  x += vx;
  y += vy;
  if (x + diameter > width) {
    x = width - diameter;
    vx *= friction; 
    oscP5.send(myMessage, myRemoteLocation);
  }
  else if (x - diameter < 0) {
    x = diameter;
    vx *= friction;
    oscP5.send(myMessage, myRemoteLocation);
  }
  if (y + diameter > height) {
    y = height - diameter;
    vy *= friction; 
    oscP5.send(myMessage, myRemoteLocation);
  } 
  else if (y - diameter < 0) {
    y = diameter;
    vy *= friction;
    oscP5.send(myMessage, myRemoteLocation);
  }
}

void display() {
  fill(255, 204);
  ellipse(x, y, diameter, diameter);
}


}

void addLusidObject(LusidObject lObj) {
}
void removeLusidObject(LusidObject lObj) {
}
void updateLusidObject(LusidObject lObg) {
}

void oscEvent(OscMessage theOscMessage)
{
  // get the first value as an integer
  int firstValue = theOscMessage.get(0).intValue();
 
  // get the second value as a float  
  float secondValue = theOscMessage.get(1).floatValue();
 
  // get the third value as a string
  String thirdValue = theOscMessage.get(2).stringValue();
 
  // print out the message
  print("OSC Message Recieved: ");
  print(theOscMessage.addrPattern() + " ");
  println(firstValue + " " + secondValue + " " + thirdValue);
}

